package com.bonus.system.basic.service;

import com.bonus.common.core.domain.R;
import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.system.api.domain.MapVo;
import com.bonus.system.api.domain.SysUser;
import com.bonus.system.api.model.LoginUser;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 用户 业务层
 *
 * @author zys
 */
public interface SysUserService {

    /**
     * 通过用户名查询用户
     *
     * @param userName 用户名
     * @return 用户对象信息
     */
    R<LoginUser> selectUserByUserName(String userName);

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    public SysUser selectUserById(Long userId);

    List<MapVo> getOrgByUserId(SysUser user);

    /**
     * 查询用户列表
     * @param bean
     * @return List<SysUser>
     */
    List<SysUser> selectUserList(SysUser bean);

    /**
     * 查询所有角色
     * @return
     */
    AjaxResult getSelectRole();

    /**
     * 新增用户
     * @param user
     * @return AjaxResult
     */
    AjaxResult insertUser(SysUser user);

    /**
     * 查询所有岗位
     * @param
     * @return
     */
    AjaxResult getSelectPost();

    /**
     * 删除用户信息
     * @param userId
     * @return
     */
    int deleteUserByIds(Long userId);

    /**
     * 校验手机号码是否唯一
     *
     * @param user 用户信息
     * @return 结果
     */
    boolean checkPhoneUnique(SysUser user);

    /**
     * 修改用户信息
     * @param user
     * @return
     */
    int updateUser(SysUser user);

    /**
     * 导入用户数据
     * @param file
     * @param request
     * @param response
     * @return
     */
    AjaxResult excelUpload(MultipartFile file, HttpServletRequest request, HttpServletResponse response);

    /**
     * 查询所有用户
     * @param
     * @return
     */
    AjaxResult getSelectUser();

    /**
     * 重置密码
     * @param user
     * @return
     */
    AjaxResult resetPwd(SysUser user);

    /**
     * 校验用户是否允许操作
     * @param user
     * @return
     */
    boolean checkIdNumberUnique(SysUser user);

    /**
     * 修改用户密码
     * @param user
     * @return
     */
    AjaxResult updatePwd(SysUser user);

    AjaxResult getSelectUserCurrent();

    /**
     * 校验用户是否允许操作
     * @param user
     * @return
     */
    boolean checkUserNameUnique(SysUser user);
//    List<MapVo> getAttGroupByUserId(SysUser user);

    /**
     * 授予更新人脸权
     * @param user
     * @return
     */
    AjaxResult updateIsFace(SysUser user);

    int checkPersonAssignment(SysUser bean);

    List<MapVo> getAttGroupByUserId(SysUser user);

    int updatePermission(SysUser user);

    List<String> getRoleList(SysUser user);
}
